---
name: Report a bug
about: Something need fixing or improvement? Let us know!
title: ''
labels: bug
assignees: ''

---

_Before opening a new bug report, please read [Reporting Bugs](https://github.com/premake/premake-core/blob/master/CONTRIBUTING.md#reporting-bugs) and consider if this is something [you can contribute](https://github.com/premake/premake-core/blob/master/CONTRIBUTING.md#contributing-a-fix-or-feature) yourself. If this a new bug, help us help you by filling in the template below._

**What seems to be the problem?**
A clear and concise description of the bug, ex. "It crashes when I try to run it" or "There doesn't seem to be any way to do ...". If you are reporting a crash, be sure to include any error messages and stack trace information. Use [code blocks](https://help.github.com/en/articles/creating-and-highlighting-code-blocks) to format code and console output nicely.

**What did you expect to happen?**
A clear and concise description of what you expected to happen.

**What have you tried so far?**
Describe any steps you've taken to try to solve or workaround the bug.

**How can we reproduce this?**
Please provide a [minimal, reproducible example](https://stackoverflow.com/help/minimal-reproducible-example) we can use to replicate the problem in our own development environments. Use [code blocks](https://help.github.com/en/articles/creating-and-highlighting-code-blocks) to format code and console output nicely.

**What version of Premake are you using?**
`premake5 --version` will show you the version. If you are running a "-dev" version, please make sure you are up to date with the latest master branch.

**Anything else we should know?**
Add any other context about the problem here.

*(You can now [support Premake on our OpenCollective](https://opencollective.com/premake). Your contributions help us spend more time responding to issues like these!)*
